/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the InstagramUserConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &InstagramUserConnectorForm{}

// InstagramUserConnectorForm struct for InstagramUserConnectorForm
type InstagramUserConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// OAuthId
	OAuthId string `json:"oAuthId"`
	// Data source label
	Label string `json:"label"`
	// Instagram account identifier
	AccountId string `json:"accountId"`
	// Instagram attributes
	Attribute []string `json:"attribute"`
	// Date range.
	DateRange string `json:"dateRange"`
}

// NewInstagramUserConnectorForm instantiates a new InstagramUserConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInstagramUserConnectorForm(connectorId string, templateId string, strategy string, oAuthId string, label string, accountId string, attribute []string, dateRange string) *InstagramUserConnectorForm {
	this := InstagramUserConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.OAuthId = oAuthId
	this.Label = label
	this.AccountId = accountId
	this.Attribute = attribute
	this.DateRange = dateRange
	return &this
}

// NewInstagramUserConnectorFormWithDefaults instantiates a new InstagramUserConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInstagramUserConnectorFormWithDefaults() *InstagramUserConnectorForm {
	this := InstagramUserConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *InstagramUserConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *InstagramUserConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *InstagramUserConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *InstagramUserConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *InstagramUserConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *InstagramUserConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *InstagramUserConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *InstagramUserConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *InstagramUserConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value
func (o *InstagramUserConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *InstagramUserConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetLabel returns the Label field value
func (o *InstagramUserConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *InstagramUserConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetAccountId returns the AccountId field value
func (o *InstagramUserConnectorForm) GetAccountId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorForm) GetAccountIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AccountId, true
}

// SetAccountId sets field value
func (o *InstagramUserConnectorForm) SetAccountId(v string) {
	o.AccountId = v
}

// GetAttribute returns the Attribute field value
func (o *InstagramUserConnectorForm) GetAttribute() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Attribute
}

// GetAttributeOk returns a tuple with the Attribute field value
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorForm) GetAttributeOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Attribute, true
}

// SetAttribute sets field value
func (o *InstagramUserConnectorForm) SetAttribute(v []string) {
	o.Attribute = v
}

// GetDateRange returns the DateRange field value
func (o *InstagramUserConnectorForm) GetDateRange() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value
// and a boolean to check if the value has been set.
func (o *InstagramUserConnectorForm) GetDateRangeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DateRange, true
}

// SetDateRange sets field value
func (o *InstagramUserConnectorForm) SetDateRange(v string) {
	o.DateRange = v
}

func (o InstagramUserConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o InstagramUserConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["oAuthId"] = o.OAuthId
	toSerialize["label"] = o.Label
	toSerialize["accountId"] = o.AccountId
	toSerialize["attribute"] = o.Attribute
	toSerialize["dateRange"] = o.DateRange
	return toSerialize, nil
}

type NullableInstagramUserConnectorForm struct {
	value *InstagramUserConnectorForm
	isSet bool
}

func (v NullableInstagramUserConnectorForm) Get() *InstagramUserConnectorForm {
	return v.value
}

func (v *NullableInstagramUserConnectorForm) Set(val *InstagramUserConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableInstagramUserConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableInstagramUserConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInstagramUserConnectorForm(val *InstagramUserConnectorForm) *NullableInstagramUserConnectorForm {
	return &NullableInstagramUserConnectorForm{value: val, isSet: true}
}

func (v NullableInstagramUserConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInstagramUserConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
